#include "Quadric.h"

#include <algorithm>

Quadric::Quadric(Mat4f pQ, Shader pShader){
    Q = pQ;
    shader = pShader;
}

Intersection Quadric::intersect(Ray ray, float tStart, float tEnd){
    // Initialize result struct (per default, hasIntersection is false):
    Intersection intersection;

    /*
     * TODO (Exercise 1b)
     *
     * Implement the intersection function with the quadric and by calculating
     * the correct ray parameter t.
     *
     * To do this, use a brute force method (3 Credits) and ensure to use a
     * sampling rate which is high enough to get all details, but not higher
     * than necessary (to safe performance).
     *
     * Then, try to make it faster by some improvements by your own (2 Credit).
     * You may use techniques you learned in the lecture, but note, that the
     * roots of Quadrics differ in their characteristics (e.g. compared to
     * metaballs) and you might have to adapt the algorithms. Your improvment
     * has to be faster than the simple brute force and should not produce any
     * other clearly visible artifacts.
     */

    // Replace this if necessary:
    float t = tStart;

    /* HERE YOU CAN SEARCH FOR AN INTERSECTION AND SET t */
    {
        /* YOUR IMPLEMENTATION */
    }

    // Calculate the intersection candidate:
    Vec4f x = ray.evaluate(t);

    // Evaluate the function at the intersection candidate:
    float fx = F(x);

    /* REPLACE THIS BY YOUR OWN CONDITION TO ENSURE F(x) is near enough to 0 */
    if(fx > 0.1f)
        return intersection;

    // We calculate the normal here:
    float eps = 0.0001f;
    Vec4f n = -Vec4f(
        F(Vec4f(x[0]-eps, x[1], x[2])) -  F(Vec4f(x[0]+eps, x[1], x[2])),
        F(Vec4f(x[0], x[1]-eps, x[2])) -  F(Vec4f(x[0], x[1]+eps, x[2])),
        F(Vec4f(x[0], x[1], x[2]-eps)) -  F(Vec4f(x[0], x[1], x[2]+eps)),
        0.f
    ).normalized();

    intersection.hasIntersection = true;
    intersection.t = t;
    intersection.hitPoint = ray.evaluate(t);
    intersection.normal = n.normalized();
    intersection.shader = &shader;

    return intersection;
}

float Quadric::F(Vec4f X){
    /*
     * TODO (Exercise 1a)
     *
     * This function should return the left part of the quadratic equation
     * x^T * Q * x = 0.
     *
     * Note: Note that the Vec4f and Mat4f do not support transposition of
     * vectors and a left-handed vector cannot be multiplied by a right-handed
     * matrix. You can either manually multiply the left transposed vector
     * with the matrix, or find an easier way ;-)
     */



    // Replace this:
    return 1.f;
}
