// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include "src/math/Mat4f.h"
#include "src/scene/Surface.h"

class Quadric : public Surface {
    Mat4f Q;

public:
    /**
     * Creates a quadric with the given matrix Q (quadratic form) and the
     * given shader.
     */
    Quadric(Mat4f Q, Shader pShader);

    /** See documentation in parent class 'Surface' */
    virtual Intersection intersect(Ray ray, float tStart, float tEnd) override;

    /**
     * Should return X^T * Q * X.
     */
    float F(Vec4f X);
};
